import { GraphQLClient } from './graphQLClient';
import { ChangeUserStatusInput } from './types';
export declare class GitHubProfileStatus {
    private client;
    constructor(client: GraphQLClient);
    /**
     * Clears the user profile status
     */
    clear(): Promise<boolean>;
    /**
     * Retrieves the status of the authenticated user
     */
    get(): Promise<import("./types").UserStatus | null>;
    /**
     * Retrieves the status of the provided user
     */
    getForUser(user: string): Promise<import("./types").UserStatus | null>;
    /**
     * Updates the user profile status
     */
    set(status: ChangeUserStatusInput): Promise<import("./types").UserStatus | null>;
    /**
     * Partially updates the provided status attribues.
     */
    update(changes: ChangeUserStatusInput): Promise<import("./types").UserStatus | null>;
    private execCommand;
}
